gfx = love.graphics
wdw = love.window
kbd = love.keyboard

function love.load()
	c = {1, 0, 0}
	cI = 0		-- color Index; affects what colours are adding/removing
	cInc = .01	-- Increment amount; the higher this is, the faster the transition. Maximum of 1!
	
	local muhCode = [[
		extern vec3 c;
		vec4 effect(vec4 color, Image tex, vec2 texCoord, vec2 pixCoord)
		{
			vec4 texCol = Texel(tex, texCoord);
			return vec4(vec3(texCol.r * c[0], texCol.g * c[1], texCol.b * c[2]), texCol.a);
		}
	]]
	
	img = gfx.newImage("frustration.jpg")
	shader = gfx.newShader(muhCode)
end

function love.update(dt)
	if cI + cInc > 3 then
		cI = -cInc
	elseif cI + cInc < 1 then
		c[3] = 0
		c[1] = math.max(0, c[1] - cInc)
		c[2] = math.min(c[2] + cInc, 1)
	elseif cI + cInc < 2 then
		c[1] = 0
		c[2] = math.max(0, c[2] - cInc)
		c[3] = math.min(c[3] + cInc, 1)
	else
		c[2] = 0
		c[3] = math.max(0, c[3] - cInc)
		c[1] = math.min(c[1] + cInc, 1)
	end
	cI = cI + cInc
	shader:send("c", c)
	
	if kbd.isDown("up") then
		cInc = math.min(cInc + .001, 1)
	elseif kbd.isDown("down") then
		cInc = math.max(cInc - .001, 0)
	end
end

function love.draw()
	for i = 1, #c do
		if i == 1 then
			gfx.setColor(255, 0, 0)
		elseif i == 2 then
			gfx.setColor(0, 255, 0)
		elseif i == 3 then
			gfx.setColor(0, 0, 255)
		end
		gfx.rectangle("fill", 100 + i * 10, wdw.getHeight() - 10 - c[i] * 50, 10, 10)	-- draws visual representation of colour strength
	end
	
	gfx.setColor(255, 255, 255)
	gfx.print("Increase/Decrease transition speed: Up/Down")
	
	gfx.setShader(shader)
	gfx.draw(img, wdw.getWidth() / 2 - img:getWidth() / 2, wdw.getHeight() / 2 - img:getHeight() / 2)
	gfx.setShader()
end